// Created in "Processing" by Craig Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A very simple visualization of angles in the plane.  
// This is intended more as a teaching demo (something we'll
// run in class) than a sketch whose source code you should
// study.  So don't worry too much if the code doesn't fit
// perfectly with the contents of the slides.

let ang;

function setup() {
  createCanvas( 500, 500 );
  ang = 0;
}

function draw() {
  background( 255 );
  stroke( 0 );
  strokeWeight( 3 );
  noFill();

  let x = 250 + 200 * cos( ang );
  let y = 250 - 200 * sin( ang );

  line( 250, 250, 450, 250 );
  line( 250, 250, x, y );

  strokeWeight( 1 );
  arc( 250, 250, 100, 100, TWO_PI-ang, TWO_PI );

  noStroke();
  fill( 0 );
  ellipse( 250, 250, 6, 6 );

  x = 250 + 80 * cos( ang / 2 );
  y = 250 - 80 * sin( ang / 2 );
  textAlign( CENTER );
  text( ang * 180 / PI, x, y );


}

function keyPressed() {
  if ( keyCode == LEFT_ARROW ) {
    ang -= 0.03;
  } else if ( keyCode == RIGHT_ARROW ) {
    ang += 0.03;
  }
}
