// Created in "Processing" by Craig Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A quick attempt to simulate the visual style of the animation
// in the video for "Do I Wanna Know" by the Arctic Monkeys.  This
// definitely makes advanced use of trigonometry functions, and you
// absolutely don't need to understand that part of the code.  Just
// note the use of beginShape()/vertex()/endShape().

function setup() {
  createCanvas( 800, 600 );
}

function draw() {
  background( 0 );
  noFill();
  stroke( 255 );
  strokeWeight( 3 );
  
  beginShape();
  for( let idx = 0; idx < width; ++idx ) {
    vertex( idx, 300 + 200.0*sin(frameCount*0.1)*sin( idx * 0.15 + frameCount*0.27 ) * sin( idx * 2.0*PI/width ) );
  }
  endShape();
}
