let bass;
let snare;

let last_hit;
let trig_amp;

function setup() {
  createCanvas( 801, 500 );

  bass = loadSound("data/am_bass.mp3" );
  snare = loadSound( "data/am_snare.mp3" );
  last_hit = -100000;
}

function getAmplitude() {  
  let amp = 0;
  let tm = millis() - last_hit;
  if ( tm < 50 ) {
    amp = map( tm, 0, 50, trig_amp, 230 );
  } else if ( tm < 500 ) {
    amp = map( tm, 50, 500, 230, 0 );
  }

  return amp;
}

function draw() {
  background( 0 );

  noFill();
  stroke( 255 );
  strokeWeight( 4 );

  let amp = getAmplitude();

  beginShape();
  if ( amp > 0.01 ) {
    for ( let idx = 0; idx < width; ++idx ) {

      let s1 = max( 0, sin( float(idx)/float(width-1) * TWO_PI * 0.95 ) );
      let s2 = max( 0, sin( float(width-1-idx)/float(width-1) * TWO_PI * 0.95 ) );

      vertex( idx, 250 - amp
        * sin( float(idx)/float(width-1) * 25.0 * PI ) 
        * lerp( s1, s2, float(idx)/float(width-1) ) );
    }
  } else {
    vertex( 0, 250 );
    vertex( 800, 250 );
  }
  endShape();
}

function triggerWave() {
  trig_amp = getAmplitude();
  last_hit = millis();
}

function keyPressed() {
  if ( key == 'b' ) {
    bass.play();
    triggerWave();
  } else if ( key == 's' ) {
    snare.play();
    triggerWave();
  }
}
