// Created in "Processing" by Craig Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// An exceedingly nasty sketch for live visualization of 
// polar coordinates.  This sketch really *does* use advanced
// features of Processing, and is definitely intended *only*
// to be demonstrated live and not studied.  Don't worry at 
// all if this code makes no sense.

let recording = false;

function setup() {
  createCanvas( 510, 510 );
  textSize( 16 );
  noCursor();
}

function draw() {
  if ( recording ) {
    saveCanvas("output", "png");
  }

  background( 255 );

  stroke( 0 );
  strokeWeight( 0.5 );
  noFill();
  for ( let idx = 0; idx < 24; ++idx ) {
    let ang = TWO_PI * idx / 24;
    line( width/2, height/2, width/2+500*cos(ang), height/2+500*sin(ang) );
  }

  for ( let idx = 0; idx < 400; idx += 50 ) {
    ellipse( width/2, height/2, 2*idx, 2*idx );
  }

  strokeWeight( 3 );
  line( width/2, height/2, width, height/2 );

  fill( 255 );
  noStroke();
  rect( 0, 0, 184, 25 );

  textSize( 20 );
  fill( 0 );
  textAlign( LEFT );
  text( "Polar coordinates", 5, 20 );

  let theta = atan2( mouseY - height/2, mouseX - width/2 );
  let r = dist( mouseX, mouseY, width/2, height/2 );

  strokeWeight( 4 );
  stroke( 255, 0, 0 );
  push();
  translate( width/2, height/2 );
  rotate( theta );
  line( 0, 0, r, 0 );
  line( 0, -10, 0, 10 );
  line( r, -10, r, 10 );

  let r_str = nf( 0.02 * r, 0, 1 );

  fill( 255, 0, 0 );
  textAlign( CENTER );
  noStroke();
  text( r_str, r/2, -5 );

  stroke( 0, 0, 255 );
  line( r - 10, 0, r + 10, 0 );
  pop();

  stroke( 0, 0, 255 );
  noFill();
  let vis_ang = 0.0;

  if ( theta >= 0 ) {
    arc( width/2, height/2, 2*r, 2*r, theta, TWO_PI );
    vis_ang = TWO_PI - theta;
  } else {
    arc( width/2, height/2, 2*r, 2*r, theta, 0  );
    vis_ang = -theta;
  }
  line( width/2 + r - 10, height/2, width/2 + r + 10, height/2 );

  let th_str = nf( degrees( vis_ang ), 0, 1 );

  // text( degrees( theta ), 50, 50 );

  fill( 0, 0, 255 );
  textAlign( LEFT );
  noStroke();
  text( th_str, 
    width/2+(r+5)*cos(vis_ang/2), 
    height/2-(r+5)*sin(vis_ang/2) );
  
  fill( 255 );
  rect( width-140, height-55, 140, 55 );

  textAlign( RIGHT );
  fill( 255, 0, 0 );
  text( "r = " + r_str, width-10, height-30 );
  fill( 0, 0, 255 );
  text( "theta = " + th_str, width-10, height-8 );

  noStroke();
  fill( 0 );
  ellipse( mouseX, mouseY, 15, 15 );

  if ( recording ) {
    recording = false;
  }
}

function keyPressed() {
  if ( key == ' ' ) {
    recording = true;
  }
}
