let pts;

function polar( r, theta ) {
  let dt = radians( theta );
  
  let x = r * cos( dt );
  let y = r * sin( dt );
  
  return createVector( x, y );
}

function setup() {
  createCanvas( 500, 500 );
  background( 100 );
  fill( 0 );
  ellipse( 250, 250, 400, 400 );
  
  pts = new Array(20);
  for( let idx = 0; idx < 20; idx += 2 ) {
    pts[idx] = random( 30, 190 );
    pts[idx+1] = random( 360 );
  }
}

function draw() {
  fill( 0, 20 );
  noStroke();
  ellipse( 250, 250, 400, 400 );
  
  noFill();
  stroke( 0, 200, 0, 200 );
  strokeWeight( 3 );
  
  let ang = frameCount % 360;
  
  let pt = polar( 198, ang );
  line( 250, 250, 250+pt.x, 250-pt.y );
  
  for( let idx = 0; idx < 20; idx += 2 ) {
    let r = pts[idx];
    let theta = pts[idx+1];
    if( abs( theta - ang  ) < 5 ) {
      let p = polar( r, theta );
      noFill();
      stroke( 0, 255, 0, 255 );
      strokeWeight( 2 );
      ellipse( 250 + p.x, 250 - p.y, 8, 8 );
    }
  }
}
