// Created in "Processing" by Craig Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A simple visualization of regular polygons, drawn
// using polar coordinates.

let num_sides = 3;

function polar( r, theta ) {
  let dt = radians( theta );
  
  let x = r * cos( dt );
  let y = r * sin( dt );
  
  return createVector( x, y );
}

function setup() {
  createCanvas( 500, 500 );
}

function draw() {
  background( 200 );
  
  stroke( 255 );
  strokeWeight( 2 );
  fill( 100 );
  
  beginShape();
  for( let idx = 0; idx < num_sides; ++idx ) {
    let ang = map( idx, 0, num_sides, 0, 360 );
    let pt = polar( 200, ang );
    vertex( width/2 + pt.x, width/2 + pt.y );
  }
  endShape( CLOSE );
}

function keyPressed() {
  if( keyCode == UP_ARROW ) {
    ++num_sides;
  } else {
    num_sides = max( 3, num_sides - 1 );
  }
}
