// Created in "Processing" by Craig S. Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A demonstration of using beginShape()/vertex()/endShape()
// to draw a graph.  In this case, we plot the amount of 
// arctic sea ice in January of each year from 1979 to 2016.
// Note that the graph is generally going down.

let samps;

function preload() {
  samps = loadStrings( "data/january.txt" );
}

function setup() {
  createCanvas( 800, 400 );
  
  // I used these lines to determine the range of the
  // graph, in order to plan how much to stretch y values
  // below.

  //console.log( max( samps ) ); // -- 15.6
  //console.log( min( samps ) ); // -- 13.64

  background( 80 );
  stroke( 255 );
  strokeWeight( 2 );
  noFill();

  beginShape();
  for ( let idx = 0; idx < samps.length; ++idx ) {
    vertex(
      map( idx, 0, samps.length-1, 0, width ), 
      map( samps[idx], 13, 17, height, 0 ) );
  }
  endShape();

  for ( let idx = 0; idx < 21; ++idx ) {
    let y = map( idx, 0, 20, height, 0 );

    noStroke();
    noFill();
    line( 0, y, 10, y );
    
    fill( 255 );
    text( "" + map( idx, 0, 20, 13, 17 ), 12, y );
  }
}
