// Created in "Processing" by Craig S. Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A very simple demonstration of polar coordinates: a point moving
// in a circle.

function polar( r, theta ) {
  let dt = radians( theta );
  
  let x = r * cos( dt );
  let y = r * sin( dt );
  
  return createVector( x, y );
}

function setup() {
  createCanvas( 500, 500 );
  background( 0 );
}

function draw() {
  let ang = -frameCount;
  
  // Use some pretty blur effects just for eye candy.
  filter( BLUR, 1 );
  fill( 255 );
  noStroke();
  
  let P = polar( 200, ang );
  ellipse( width/2 + P.x, height/2 + P.y, 30, 30 );
}
