// Created in "Processing" by Craig S. Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A fun visualization of lots of fancy
// spirals, including the generalization to
// pretty geometric patterns.

function polar( r, theta ) {
  let dt = radians( theta );
  
  let x = r * cos( dt );
  let y = r * sin( dt );
  
  return createVector( x, y );
}

function setup() {
  createCanvas( 500, 500 );
}

function draw() {
  background( 50 );
  
  stroke( 255 );
  strokeWeight( 2 );
  noFill();
  
  beginShape();
  
  let theta_mult = map( mouseX, 0, width, 0.5, 180 );
  let r_inc = map( mouseY, 0, height, 0.01, 1.0 );
  
  for( let idx = 0;; ++idx ) {
    let theta = idx * theta_mult;
    let r = theta * r_inc;
    
    if( r > 300 ) {
      break;
    }
    
    let pt = polar( r, theta );
    vertex( width/2 + pt.x, width/2 + pt.y );
  }
  endShape();
}
