// Created in "Processing" by Craig S. Kaplan.
// Modified for "JavaScript p5" in December 2019 by Muhammad Muddassir Malik.
// A (relatively) simple recreation of the
// cover of the Joy Division album "Unknown Pleasures".

function setup() {
  createCanvas( 400, 600 );

  background( 0 );
  fill( 0 );
  stroke( 255 );
  strokeWeight( 2 );

  for ( let y = 100; y < 540; y += 10 ) {
    beginShape();
    vertex( 0, y );
    for ( let idx = 50; idx < 350; idx += 10 ) {
      // Do a little bit of magic math to weight the
      // randomness below by a scaling factor that
      // makes it die out towards the edges of the
      // design.
      
      let offset = (idx - 200.0) * 0.03;
      let amp = 1.0 / (1.0 + sq(offset));
      vertex( idx, y - amp*random( 40 ) );
    }
    vertex( width, y );
    vertex( width, height+5 );
    vertex( 0, height+5 );
    endShape();
  }
  
  // Cover up all the extra white lines drawn above 
  // to make the result look more like the album cover.
  noStroke();
  rect( 0, 0, 50, height );
  rect( width-50, 0, 50, height );
}
